diff --git a/libinterp/corefcn/Cell.cc b/libinterp/corefcn/Cell.cc
index d5fb636..3ac9d63 100644
--- a/libinterp/corefcn/Cell.cc
+++ b/libinterp/corefcn/Cell.cc
@@ -162,51 +162,64 @@ Cell::index (const octave_value_list& idx_arg, bool resize_ok) const
 
   octave_idx_type n = idx_arg.length ();
 
-  switch (n)
-    {
-    case 0:
-      retval = *this;
-      break;
-
-    case 1:
-      {
-        idx_vector i = idx_arg(0).index_vector ();
-
-        if (! error_state)
-          retval = Array<octave_value>::index (i, resize_ok, Matrix ());
-      }
-      break;
-
-    case 2:
-      {
-        idx_vector i = idx_arg(0).index_vector ();
-
-        if (! error_state)
-          {
-            idx_vector j = idx_arg(1).index_vector ();
-
-            if (! error_state)
-              retval = Array<octave_value>::index (i, j, resize_ok, Matrix ());
-          }
-      }
-      break;
-
-    default:
-      {
-        Array<idx_vector> iv (dim_vector (n, 1));
-
-        for (octave_idx_type i = 0; i < n; i++)
-          {
-            iv(i) = idx_arg(i).index_vector ();
-
-            if (error_state)
-              break;
-          }
+    // If we catch an indexing error in  index_vector(),  we flag an error in
+    // index  k.  Ensure it is the right value befor each idx_vector() call.
+    // Same variable as used in for() loop in default: case.
+  octave_idx_type k = 0;
 
-        if (!error_state)
-          retval = Array<octave_value>::index (iv, resize_ok, Matrix ());
-      }
-      break;
+  try
+    {
+      switch (n)
+	{
+	case 0:
+	  retval = *this;
+	  break;
+
+	case 1:
+	  {
+	    idx_vector i = idx_arg(0).index_vector ();
+
+	    if (! error_state)
+	      retval = Array<octave_value>::index (i, resize_ok, Matrix ());
+	  }
+	  break;
+
+	case 2:
+	  {
+	    idx_vector i = idx_arg(0).index_vector ();
+
+	    if (! error_state)
+	      {
+	        k = 1;
+		idx_vector j = idx_arg(1).index_vector ();
+
+		if (! error_state)
+		  retval = Array<octave_value>::index (i, j, resize_ok, Matrix ());
+	      }
+	  }
+	  break;
+
+	default:
+	  {
+	    Array<idx_vector> iv (dim_vector (n, 1));
+
+	    for (k = 0; k < n; k++)
+	      {
+		iv(k) = idx_arg(k).index_vector ();
+
+		if (error_state)
+		  break;
+	      }
+	    if (!error_state)
+	      retval = Array<octave_value>::index (iv, resize_ok, Matrix ());
+	  }
+	  break;
+	}
+    }
+  catch (idx_except& e)
+    {
+      e.set_pos_if_unset (n, k+1);
+      throw;   // caught in pt-idx.cc / pt-assign.cc, when var name known
     }
 
   return retval;
@@ -228,7 +241,17 @@ Cell::assign (const octave_value_list& idx_arg, const Cell& rhs,
   Array<idx_vector> ra_idx (dim_vector (len, 1));
 
   for (octave_idx_type i = 0; i < len; i++)
-    ra_idx(i) = idx_arg(i).index_vector ();
+    {
+      try
+        {
+          ra_idx(i) = idx_arg(i).index_vector ();
+        }
+      catch (idx_except& e)
+        {
+	  e.set_pos (len, i+1);
+	  throw;		// to be caught in pt-idx.cc  or  pt-assign.cc
+        }
+    }
 
   Array<octave_value>::assign (ra_idx, rhs, fill_val);
 }
@@ -242,7 +265,15 @@ Cell::delete_elements (const octave_value_list& idx_arg)
   Array<idx_vector> ra_idx (dim_vector (len, 1));
 
   for (octave_idx_type i = 0; i < len; i++)
-    ra_idx.xelem (i) = idx_arg(i).index_vector ();
+    try
+      {
+	ra_idx.xelem (i) = idx_arg(i).index_vector ();
+      }
+    catch (idx_except& e)
+        {
+	  e.set_pos (len, i+1);
+	  throw;		// to be caught in pt-idx.cc  or  pt-assign.cc
+        }
 
   Array<octave_value>::delete_elements (ra_idx);
 }
diff --git a/libinterp/corefcn/data.cc b/libinterp/corefcn/data.cc
index c132ba4..3ae184e 100644
--- a/libinterp/corefcn/data.cc
+++ b/libinterp/corefcn/data.cc
@@ -7169,44 +7169,51 @@ the ratio K/M is small; otherwise, it may be better to use @code{sort}.\n\
       if (dim < 0)
         dim = argx.dims ().first_non_singleton ();
 
-      idx_vector n = args(1).index_vector ();
+      try
+        {
+          idx_vector n = args(1).index_vector ();
 
-      if (error_state)
-        return retval;
+          if (error_state)
+            return retval;
 
-      switch (argx.builtin_type ())
-        {
-        case btyp_double:
-          retval = argx.array_value ().nth_element (n, dim);
-          break;
-        case btyp_float:
-          retval = argx.float_array_value ().nth_element (n, dim);
-          break;
-        case btyp_complex:
-          retval = argx.complex_array_value ().nth_element (n, dim);
-          break;
-        case btyp_float_complex:
-          retval = argx.float_complex_array_value ().nth_element (n, dim);
-          break;
+          switch (argx.builtin_type ())
+            {
+            case btyp_double:
+              retval = argx.array_value ().nth_element (n, dim);
+              break;
+            case btyp_float:
+              retval = argx.float_array_value ().nth_element (n, dim);
+              break;
+            case btyp_complex:
+              retval = argx.complex_array_value ().nth_element (n, dim);
+              break;
+            case btyp_float_complex:
+              retval = argx.float_complex_array_value ().nth_element (n, dim);
+              break;
 #define MAKE_INT_BRANCH(X) \
-        case btyp_ ## X: \
-          retval = argx.X ## _array_value ().nth_element (n, dim); \
-          break;
+            case btyp_ ## X: \
+              retval = argx.X ## _array_value ().nth_element (n, dim); \
+              break;
 
-        MAKE_INT_BRANCH (int8);
-        MAKE_INT_BRANCH (int16);
-        MAKE_INT_BRANCH (int32);
-        MAKE_INT_BRANCH (int64);
-        MAKE_INT_BRANCH (uint8);
-        MAKE_INT_BRANCH (uint16);
-        MAKE_INT_BRANCH (uint32);
-        MAKE_INT_BRANCH (uint64);
+            MAKE_INT_BRANCH (int8);
+            MAKE_INT_BRANCH (int16);
+            MAKE_INT_BRANCH (int32);
+            MAKE_INT_BRANCH (int64);
+            MAKE_INT_BRANCH (uint8);
+            MAKE_INT_BRANCH (uint16);
+            MAKE_INT_BRANCH (uint32);
+            MAKE_INT_BRANCH (uint64);
 #undef MAKE_INT_BRANCH
-        default:
-          if (argx.is_cellstr ())
-            retval = argx.cellstr_value ().nth_element (n, dim);
-          else
-            gripe_wrong_type_arg ("nth_element", argx);
+            default:
+              if (argx.is_cellstr ())
+                retval = argx.cellstr_value ().nth_element (n, dim);
+              else
+                gripe_wrong_type_arg ("nth_element", argx);
+            }
+        }
+      catch (idx_except& e)
+        {
+          error ("nth_element: invalid N value %s. %s", e.idx (), e.explain ());
         }
     }
   else
@@ -7248,42 +7255,50 @@ Undocumented internal function.\n\
   int nargin = args.length ();
   if (nargin >= 2 && nargin <= 3 && args(0).is_numeric_type ())
     {
-      idx_vector idx = args(0).index_vector ();
-      octave_idx_type n = -1;
-      if (nargin == 3)
-        n = args(2).idx_type_value (true);
-
-      if (! error_state)
+      try
         {
-          octave_value vals = args(1);
-          if (vals.is_range ())
-            {
-              Range r = vals.range_value ();
-              if (r.inc () == 0)
-                vals = r.base ();
-            }
+          idx_vector idx = args(0).index_vector ();
+          octave_idx_type n = -1;
+          if (nargin == 3)
+            n = args(2).idx_type_value (true);
 
-          if (vals.is_single_type ())
-            {
-              if (vals.is_complex_type ())
-                retval = do_accumarray_sum (idx,
-                                            vals.float_complex_array_value (),
-                                            n);
-              else
-                retval = do_accumarray_sum (idx, vals.float_array_value (), n);
-            }
-          else if (vals.is_numeric_type () || vals.is_bool_type ())
+          if (! error_state)
             {
-              if (vals.is_complex_type ())
-                retval = do_accumarray_sum (idx,
-                                            vals.complex_array_value (),
-                                            n);
+              octave_value vals = args(1);
+              if (vals.is_range ())
+                {
+                  Range r = vals.range_value ();
+                  if (r.inc () == 0)
+                    vals = r.base ();
+                }
+
+              if (vals.is_single_type ())
+                {
+                  if (vals.is_complex_type ())
+                    retval = do_accumarray_sum (idx,
+                                                vals.float_complex_array_value (),
+                                                n);
+                  else
+                    retval = do_accumarray_sum (idx, vals.float_array_value (), n);
+                }
+              else if (vals.is_numeric_type () || vals.is_bool_type ())
+                {
+                  if (vals.is_complex_type ())
+                    retval = do_accumarray_sum (idx,
+                                                vals.complex_array_value (),
+                                                n);
+                  else
+                    retval = do_accumarray_sum (idx, vals.array_value (), n);
+                }
               else
-                retval = do_accumarray_sum (idx, vals.array_value (), n);
+                gripe_wrong_type_arg ("accumarray", vals);
             }
-          else
-            gripe_wrong_type_arg ("accumarray", vals);
-        }
+          }
+        catch (idx_except& e)
+          {
+            error ("__accumarray_sum__: invalid IDX %s. %s",
+                                        e.idx(), e.explain ());
+          }
     }
   else
     print_usage ();
@@ -7328,60 +7343,69 @@ do_accumarray_minmax_fun (const octave_value_list& args,
   int nargin = args.length ();
   if (nargin >= 3 && nargin <= 4 && args(0).is_numeric_type ())
     {
-      idx_vector idx = args(0).index_vector ();
-      octave_idx_type n = -1;
-      if (nargin == 4)
-        n = args(3).idx_type_value (true);
-
-      if (! error_state)
+      try
         {
-          octave_value vals = args(1);
-          octave_value zero = args(2);
+          idx_vector idx = args(0).index_vector ();
+          octave_idx_type n = -1;
+          if (nargin == 4)
+            n = args(3).idx_type_value (true);
 
-          switch (vals.builtin_type ())
+          if (! error_state)
             {
-            case btyp_double:
-              retval = do_accumarray_minmax (idx, vals.array_value (), n, ismin,
-                                             zero.double_value ());
-              break;
-            case btyp_float:
-              retval = do_accumarray_minmax (idx, vals.float_array_value (), n,
-                                             ismin, zero.float_value ());
-              break;
-            case btyp_complex:
-              retval = do_accumarray_minmax (idx, vals.complex_array_value (),
-                                             n, ismin, zero.complex_value ());
-              break;
-            case btyp_float_complex:
-              retval = do_accumarray_minmax (idx,
-                                             vals.float_complex_array_value (),
-                                             n, ismin,
-                                             zero.float_complex_value ());
-              break;
+              octave_value vals = args(1);
+              octave_value zero = args(2);
+
+              switch (vals.builtin_type ())
+                {
+                case btyp_double:
+                  retval = do_accumarray_minmax (idx, vals.array_value (), n, ismin,
+                                                 zero.double_value ());
+                  break;
+                case btyp_float:
+                  retval = do_accumarray_minmax (idx, vals.float_array_value (), n,
+                                                 ismin, zero.float_value ());
+                  break;
+                case btyp_complex:
+                  retval = do_accumarray_minmax (idx, vals.complex_array_value (),
+                                                 n, ismin, zero.complex_value ());
+                  break;
+                case btyp_float_complex:
+                  retval = do_accumarray_minmax (idx,
+                                                 vals.float_complex_array_value (),
+                                                 n, ismin,
+                                                 zero.float_complex_value ());
+                  break;
 #define MAKE_INT_BRANCH(X) \
-            case btyp_ ## X: \
-              retval = do_accumarray_minmax (idx, vals.X ## _array_value (), \
-                                             n, ismin, \
-                                             zero.X ## _scalar_value ()); \
-              break;
+                case btyp_ ## X: \
+                  retval = do_accumarray_minmax (idx, vals.X ## _array_value (), \
+                                                 n, ismin, \
+                                                 zero.X ## _scalar_value ()); \
+                  break;
 
-            MAKE_INT_BRANCH (int8);
-            MAKE_INT_BRANCH (int16);
-            MAKE_INT_BRANCH (int32);
-            MAKE_INT_BRANCH (int64);
-            MAKE_INT_BRANCH (uint8);
-            MAKE_INT_BRANCH (uint16);
-            MAKE_INT_BRANCH (uint32);
-            MAKE_INT_BRANCH (uint64);
+                MAKE_INT_BRANCH (int8);
+                MAKE_INT_BRANCH (int16);
+                MAKE_INT_BRANCH (int32);
+                MAKE_INT_BRANCH (int64);
+                MAKE_INT_BRANCH (uint8);
+                MAKE_INT_BRANCH (uint16);
+                MAKE_INT_BRANCH (uint32);
+                MAKE_INT_BRANCH (uint64);
 #undef MAKE_INT_BRANCH
-            case btyp_bool:
-              retval = do_accumarray_minmax (idx, vals.array_value (), n, ismin,
-                                             zero.bool_value ());
-              break;
-            default:
-              gripe_wrong_type_arg ("accumarray", vals);
+                case btyp_bool:
+                  retval = do_accumarray_minmax (idx, vals.array_value (), n, ismin,
+                                                 zero.bool_value ());
+                  break;
+                default:
+                  gripe_wrong_type_arg ("accumarray", vals);
+                }
             }
         }
+      catch (idx_except& e)
+        {
+          error ("do_accumarray_minmax_fun: invalid index %s. %s",
+                                        e.idx (), e.explain ());
+        }
+
     }
   else
     print_usage ();
@@ -7448,39 +7472,46 @@ Undocumented internal function.\n\
   int nargin = args.length ();
   if (nargin >= 2 && nargin <= 4 && args(0).is_numeric_type ())
     {
-      idx_vector idx = args(0).index_vector ();
-      int dim = -1;
-      if (nargin >= 3)
-        dim = args(2).int_value () - 1;
-
-      octave_idx_type n = -1;
-      if (nargin == 4)
-        n = args(3).idx_type_value (true);
-
-      if (! error_state)
+      try
         {
-          octave_value vals = args(1);
+          idx_vector idx = args(0).index_vector ();
+          int dim = -1;
+          if (nargin >= 3)
+            dim = args(2).int_value () - 1;
 
-          if (vals.is_single_type ())
-            {
-              if (vals.is_complex_type ())
-                retval = do_accumdim_sum (idx,
-                                          vals.float_complex_array_value (),
-                                          dim, n);
-              else
-                retval = do_accumdim_sum (idx, vals.float_array_value (),
-                                          dim, n);
-            }
-          else if (vals.is_numeric_type () || vals.is_bool_type ())
+          octave_idx_type n = -1;
+          if (nargin == 4)
+            n = args(3).idx_type_value (true);
+
+          if (! error_state)
             {
-              if (vals.is_complex_type ())
-                retval = do_accumdim_sum (idx, vals.complex_array_value (),
-                                          dim, n);
+              octave_value vals = args(1);
+
+              if (vals.is_single_type ())
+                {
+                  if (vals.is_complex_type ())
+                    retval = do_accumdim_sum (idx,
+                                              vals.float_complex_array_value (),
+                                              dim, n);
+                  else
+                    retval = do_accumdim_sum (idx, vals.float_array_value (),
+                                              dim, n);
+                }
+              else if (vals.is_numeric_type () || vals.is_bool_type ())
+                {
+                  if (vals.is_complex_type ())
+                    retval = do_accumdim_sum (idx, vals.complex_array_value (),
+                                              dim, n);
+                  else
+                    retval = do_accumdim_sum (idx, vals.array_value (), dim, n);
+                }
               else
-                retval = do_accumdim_sum (idx, vals.array_value (), dim, n);
+                gripe_wrong_type_arg ("accumdim", vals);
             }
-          else
-            gripe_wrong_type_arg ("accumdim", vals);
+        }
+      catch (idx_except& e)
+        {
+          error ("__accumdim_sum__: invalid IDX %s. %s", e.idx(), e.explain ());
         }
     }
   else
diff --git a/libinterp/corefcn/find.cc b/libinterp/corefcn/find.cc
index b38d0c3..d9e47d0 100644
--- a/libinterp/corefcn/find.cc
+++ b/libinterp/corefcn/find.cc
@@ -456,6 +456,8 @@ b = sparse (i, j, v, sz(1), sz(2));\n\
           // This case is equivalent to extracting indices from a logical
           // matrix. Try to reuse the possibly cached index vector.
           retval(0) = arg.index_vector ().unmask ();
+          // No need to catch idx_except, since arg is bool.
+          // Out-of-range errors have already set pos, and will be caught later
         }
       else
         {
diff --git a/libinterp/corefcn/oct-map.cc b/libinterp/corefcn/oct-map.cc
index 8054b24..4dc726f 100644
--- a/libinterp/corefcn/oct-map.cc
+++ b/libinterp/corefcn/oct-map.cc
@@ -900,46 +900,60 @@ octave_map::index (const octave_value_list& idx, bool resize_ok) const
   octave_idx_type n_idx = idx.length ();
   octave_map retval;
 
-  switch (n_idx)
-    {
-    case 1:
-      {
-        idx_vector i = idx(0).index_vector ();
+    // If we catch an indexing error in  index_vector(),  we flag an error in
+    // index  k.  Ensure it is the right value befor each idx_vector() call.
+    // Same variable as used in for() loop in default: case.
+  octave_idx_type k = 0;
 
-        if (! error_state)
-          retval = index (i, resize_ok);
-      }
-      break;
+  try
+    {
+      switch (n_idx)
+        {
+        case 1:
+          {
+            idx_vector i = idx(0).index_vector ();
 
-    case 2:
-      {
-        idx_vector i = idx(0).index_vector ();
+            if (! error_state)
+              retval = index (i, resize_ok);
+          }
+          break;
 
-        if (! error_state)
+        case 2:
           {
-            idx_vector j = idx(1).index_vector ();
+            idx_vector i = idx(0).index_vector ();
 
-            retval = index (i, j, resize_ok);
-          }
-      }
-      break;
+            if (! error_state)
+              {
+                k = 1;
+                idx_vector j = idx(1).index_vector ();
 
-    default:
-      {
-        Array<idx_vector> ia (dim_vector (n_idx, 1));
+                retval = index (i, j, resize_ok);
+              }
+          }
+          break;
 
-        for (octave_idx_type i = 0; i < n_idx; i++)
+        default:
           {
-            ia(i) = idx(i).index_vector ();
+            Array<idx_vector> ia (dim_vector (n_idx, 1));
 
-            if (error_state)
-              break;
-          }
+            for (k = 0; k < n_idx; k++)
+              {
+                ia(k) = idx(k).index_vector ();
+
+                if (error_state)
+                  break;
+              }
 
-        if (! error_state)
-          retval = index (ia, resize_ok);
-      }
-      break;
+            if (! error_state)
+              retval = index (ia, resize_ok);
+          }
+          break;
+        }
+    }
+  catch (idx_except& e)
+    {
+      e.set_pos_if_unset (n_idx, k+1);
+      throw;   // caught in pt-idx.cc / pt-assign.cc, when var name known
     }
 
   return retval;
@@ -1094,46 +1108,60 @@ octave_map::assign (const octave_value_list& idx, const octave_map& rhs)
 {
   octave_idx_type n_idx = idx.length ();
 
-  switch (n_idx)
-    {
-    case 1:
-      {
-        idx_vector i = idx(0).index_vector ();
+    // If we catch an indexing error in  index_vector(),  we flag an error in
+    // index  k.  Ensure it is the right value befor each idx_vector() call.
+    // Same variable as used in for() loop in default: case.
+  octave_idx_type k = 0;
 
-        if (! error_state)
-          assign (i, rhs);
-      }
-      break;
+  try
+    {
+      switch (n_idx)
+        {
+        case 1:
+          {
+                idx_vector i = idx(0).index_vector ();
 
-    case 2:
-      {
-        idx_vector i = idx(0).index_vector ();
+                if (! error_state)
+                  assign (i, rhs);
+          }
+          break;
 
-        if (! error_state)
+        case 2:
           {
-            idx_vector j = idx(1).index_vector ();
+            idx_vector i = idx(0).index_vector ();
 
-            assign (i, j, rhs);
-          }
-      }
-      break;
+            if (! error_state)
+              {
+                k = 1;
+                idx_vector j = idx(1).index_vector ();
 
-    default:
-      {
-        Array<idx_vector> ia (dim_vector (n_idx, 1));
+                assign (i, j, rhs);
+              }
+          }
+          break;
 
-        for (octave_idx_type i = 0; i < n_idx; i++)
+        default:
           {
-            ia(i) = idx(i).index_vector ();
+            Array<idx_vector> ia (dim_vector (n_idx, 1));
 
-            if (error_state)
-              break;
-          }
+            for (k = 0; k < n_idx; k++)
+              {
+                ia(k) = idx(k).index_vector ();
+
+                if (error_state)
+                  break;
+              }
 
-        if (! error_state)
-          assign (ia, rhs);
-      }
-      break;
+            if (! error_state)
+              assign (ia, rhs);
+          }
+          break;
+        }
+    }
+  catch (idx_except& e)
+    {
+      e.set_pos_if_unset (n_idx, k+1);
+      throw;   // caught in pt-idx.cc / pt-assign.cc, when var name known
     }
 }
 
@@ -1244,7 +1272,15 @@ octave_map::delete_elements (const octave_value_list& idx)
 
   for (octave_idx_type i = 0; i < n_idx; i++)
     {
-      ia(i) = idx(i).index_vector ();
+      try
+        {
+          ia(i) = idx(i).index_vector ();
+        }
+      catch (idx_except& e)
+        {
+          e.set_pos_if_unset (n_idx, i+1);
+          throw;   // caught in pt-idx.cc / pt-assign.cc, when var name known
+        }
 
       if (error_state)
         break;
diff --git a/libinterp/corefcn/sparse.cc b/libinterp/corefcn/sparse.cc
index b5da61c..6f2b159 100644
--- a/libinterp/corefcn/sparse.cc
+++ b/libinterp/corefcn/sparse.cc
@@ -198,20 +198,30 @@ Compressed Column Sparse (rows = 3, cols = 4, nnz = 2 [17%])\n\
 
           if (! error_state)
             {
-              idx_vector i = args(0).index_vector ();
-              idx_vector j = args(1).index_vector ();
+              int k = 0;    // index we're checking when index_vector throws
+              try
+                {
+                  idx_vector i = args(0).index_vector ();
+                  k = 1;
+                  idx_vector j = args(1).index_vector ();
 
-              if (args(2).is_bool_type ())
-                retval = SparseBoolMatrix (args(2).bool_array_value (), i, j,
+                  if (args(2).is_bool_type ())
+                    retval = SparseBoolMatrix (args(2).bool_array_value (), i,j,
+                                               m, n, summation, nzmax);
+                  else if (args(2).is_complex_type ())
+                    retval = SparseComplexMatrix (args(2).complex_array_value(),
+                                                  i, j, m, n, summation, nzmax);
+                  else if (args(2).is_numeric_type ())
+                    retval = SparseMatrix (args(2).array_value (), i, j,
                                            m, n, summation, nzmax);
-              else if (args(2).is_complex_type ())
-                retval = SparseComplexMatrix (args(2).complex_array_value (),
-                                              i, j, m, n, summation, nzmax);
-              else if (args(2).is_numeric_type ())
-                retval = SparseMatrix (args(2).array_value (), i, j,
-                                       m, n, summation, nzmax);
-              else
-                gripe_wrong_type_arg ("sparse", args(2));
+                  else
+                    gripe_wrong_type_arg ("sparse", args(2));
+                }
+              catch (idx_except& e)
+                {
+                  e.set_pos_if_unset (2, k+1);
+                  throw;   // caught in pt-idx.cc / pt-assign.cc to get var name
+                }
             }
 
         }
diff --git a/libinterp/corefcn/sub2ind.cc b/libinterp/corefcn/sub2ind.cc
index 8465a11..3b03d73 100644
--- a/libinterp/corefcn/sub2ind.cc
+++ b/libinterp/corefcn/sub2ind.cc
@@ -99,11 +99,21 @@ linear_index = sub2ind ([3, 3], 2, 3)\n\
             {
               if (args(j+1).is_numeric_type ())
                 {
-                  idxa(j) = args(j+1).index_vector ();
-                  if (error_state)
-                    break;
-                  else if (j > 0 && args(j+1).dims () != args(1).dims ())
-                    error ("sub2ind: all subscripts must be of the same size");
+                  try
+                    {
+                      idxa(j) = args(j+1).index_vector ();
+                      if (error_state)
+                        break;
+                      else if (j > 0 && args(j+1).dims () != args(1).dims ())
+                        error ("sub2ind: all subscripts must be of the same size");
+                    }
+                  catch (idx_except& e)
+                    {
+		      e.set_pos_if_unset (nargin-1, j+1);
+		      e.set_var ("");	  // no particular variable
+		      (*current_liboctave_error_with_id_handler)
+                                                        (e.id(), e.err());
+                    }
                 }
               else
                 error ("sub2ind: subscripts must be numeric");
@@ -134,23 +144,23 @@ linear_index = sub2ind ([3, 3], 2, 3)\n\
 
 # Test low index
 %!assert (sub2ind ([10 10 10], 1, 1, 1), 1)
-%!error <subscript indices> sub2ind ([10 10 10], 0, 1, 1)
-%!error <subscript indices> sub2ind ([10 10 10], 1, 0, 1)
-%!error <subscript indices> sub2ind ([10 10 10], 1, 1, 0)
+%!error <index \(0,_,_\)> sub2ind ([10 10 10], 0, 1, 1)
+%!error <index \(_,0,_\)> sub2ind ([10 10 10], 1, 0, 1)
+%!error <index \(_,_,0\)> sub2ind ([10 10 10], 1, 1, 0)
 
 # Test high index
 %!assert (sub2ind ([10 10 10], 10, 10, 10), 1000)
-%!error <index out of range> sub2ind ([10 10 10], 11, 10, 10)
-%!error <index out of range> sub2ind ([10 10 10], 10, 11, 10)
-%!error <index out of range> sub2ind ([10 10 10], 10, 10, 11)
+%!error <index \(11,_,_\); out of bound 10> sub2ind ([10 10 10], 11, 10, 10)
+%!error <index \(_,11,_\); out of bound 10> sub2ind ([10 10 10], 10, 11, 10)
+%!error <index \(_,_,11\); out of bound 10> sub2ind ([10 10 10], 10, 10, 11)
 
 # Test high index in the trailing dimensions
 %!assert (sub2ind ([10, 1], 2, 1, 1), 2)
-%!error <index out of range> sub2ind ([10, 1], 1, 2, 1)
-%!error <index out of range> sub2ind ([10, 1], 1, 1, 2)
+%!error <index \(_,2,_\); out of bound 1> sub2ind ([10, 1], 1, 2, 1)
+%!error <index \(_,_,2\); out of bound 1> sub2ind ([10, 1], 1, 1, 2)
 %!assert (sub2ind ([10 10], 2, 2, 1), 12)
-%!error <index out of range> sub2ind ([10 10], 2, 1, 2)
-%!error <index out of range> sub2ind ([10 10], 1, 2, 2)
+%!error <index \(_,_,2\); out of bound 1> sub2ind ([10 10], 2, 1, 2)
+%!error <index \(_,_,2\); out of bound 1> sub2ind ([10 10], 1, 2, 2)
 
 # Test handling of empty arguments
 %!assert (sub2ind ([10 10], zeros (0,0), zeros (0,0)), zeros (0,0))
@@ -164,8 +174,8 @@ linear_index = sub2ind ([3, 3], 2, 3)\n\
 
 ## Test input validation
 %!error <dimension vector> sub2ind ([10 10.5], 1, 1)
-%!error <subscript indices> sub2ind ([10 10], 1.5, 1)
-%!error <subscript indices> sub2ind ([10 10], 1, 1.5)
+%!error <index \(1.5,_\)> sub2ind ([10 10], 1.5, 1)
+%!error <index \(_,1.5\)> sub2ind ([10 10], 1, 1.5)
 */
 
 DEFUN (ind2sub, args, nargout,
@@ -195,14 +205,21 @@ moving from one column to next, filling up all rows in each column.\n\
   else
     {
       dim_vector dv = get_dim_vector (args(0), "ind2sub");
-      idx_vector idx = args(1).index_vector ();
-      if (! error_state)
+      try
         {
-          if (nargout > dv.length ())
-            dv = dv.redim (nargout);
+          idx_vector idx = args(1).index_vector ();
+          if (! error_state)
+            {
+              if (nargout > dv.length ())
+                dv = dv.redim (nargout);
 
-          Array<idx_vector> idxa = ind2sub (dv, idx);
-          retval = Array<octave_value> (idxa);
+              Array<idx_vector> idxa = ind2sub (dv, idx);
+              retval = Array<octave_value> (idxa);
+            }
+        }
+      catch (idx_except& e)
+        {
+          error ("ind2sub: Invalid index %s. %s", e.idx (), e.explain ());
         }
     }
 
diff --git a/libinterp/corefcn/toplev.cc b/libinterp/corefcn/toplev.cc
index ef869b7..ef7febe 100644
--- a/libinterp/corefcn/toplev.cc
+++ b/libinterp/corefcn/toplev.cc
@@ -643,6 +643,11 @@ main_loop (void)
           if (quitting_gracefully)
             return exit_status;
         }
+      catch (idx_except& e)
+        {
+          recover_from_exception ();
+	  std::cerr << "error: unhandled index exception: " << e.err() << std::endl << "-- trying to return to prompt" << std::endl;
+        }
       catch (octave_execution_exception)
         {
           recover_from_exception ();
diff --git a/libinterp/corefcn/utils.cc b/libinterp/corefcn/utils.cc
index 24263f9..78db431 100644
--- a/libinterp/corefcn/utils.cc
+++ b/libinterp/corefcn/utils.cc
@@ -1239,10 +1239,18 @@ dims_to_numel (const dim_vector& dims, const octave_value_list& idx)
             retval *= idxi.numel ();
           else
             {
-              idx_vector jdx = idxi.index_vector ();
-              if (error_state)
-                break;
-              retval *= jdx.length (dv(i));
+              try
+                {
+                  idx_vector jdx = idxi.index_vector ();
+                  if (error_state)
+                    break;
+                  retval *= jdx.length (dv(i));
+                }
+              catch (idx_except& e)
+                {
+                  error ("dims_to_numel: Invalid IDX %s. %s",
+                                                        e.idx (), e.explain ());
+                }
             }
         }
     }
